"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LiveDotIcon = void 0;

var _preact = require("preact");

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

class LiveDotIcon extends _preact.Component {
  constructor(props) {
    super(props);
    this.count = 8;
    this.setSpeed(props.speed || 1000);
  }

  setSpeed(newSpeed) {
    this.currentSpeed = Math.round(newSpeed);
    this.currentDuration = "".concat(Math.round(this.currentSpeed * 3), "ms");
  }

  updateSpeed(newSpeed) {
    const updated = Math.round(newSpeed);

    if (updated !== this.currentSpeed) {
      this.setSpeed(updated);
    }
  }

  componentDidMount() {
    this.startAnimation();
  }

  shouldComponentUpdate(props) {
    if (props.size !== this.props.size) {
      return true;
    }

    return false;
  }

  UNSAFE_componentWillReceiveProps(props) {
    this.updateSpeed(props.speed);
  }

  getNextEl() {
    return this.base && this.base.querySelector('circle:not(.run)');
  }

  startAnimation() {
    const runNext = () => {
      const el = this.getNextEl();

      if (el) {
        el.style.animationDuration = this.currentDuration;
        el.classList.add('run');
      }

      requestAnimationFrame(scheduleNext);
    };

    const scheduleNext = () => {
      this.timeoutId = setTimeout(runNext, this.currentSpeed);
    };

    runNext();
  }

  render() {
    const _this$props = this.props,
          {
      size = 24
    } = _this$props,
          rest = _objectWithoutProperties(_this$props, ["size"]);

    const usableSize = size * 0.98;
    const halfSize = usableSize / 2;
    const middle = size / 2;
    const circles = [];

    for (let i = 0; i < this.count; i++) {
      circles.push((0, _preact.h)("circle", {
        key: "circle".concat(i),
        cx: middle,
        cy: middle,
        r: halfSize
      }));
    }

    return (0, _preact.h)("svg", _extends({
      className: "live-animation",
      width: size,
      height: size,
      onAnimationEnd: el => el.target.classList.remove('run')
    }, rest), circles);
  }

}

exports.LiveDotIcon = LiveDotIcon;